Codeforces700B. Connecting Universities

B. Connecting Universities
time limit per test
3 seconds
memory limit per test
256 megabytes
input
standard input
output
standard output

Treeland is a country in which there are n towns connected by n - 1 two-way road such that it's possible to get from any town to any other town.

In Treeland there are 2k universities which are located in different towns.

Recently, the president signed the decree to connect universities by high-speed network.The Ministry of Education understood the decree in its own way and decided that it was enough to connect each university with another one by using a cable. Formally, the decree will be done!

To have the maximum sum in the budget, the Ministry decided to divide universities into pairs so that the total length of the required cable will be maximum. In other words, the total distance between universities in k pairs should be as large as possible.

Help the Ministry to find the maximum total distance. Of course, each university should be present in only one pair. Consider that all roads have the same length which is equal to 1.

Input

The first line of the input contains two integers n and k (2 ≤ n ≤ 200 000, 1 ≤ k ≤ n / 2) — the number of towns in Treeland and the number of university pairs. Consider that towns are numbered from 1 to n.

The second line contains 2k distinct integers u1, u2, ..., u2k (1 ≤ ui ≤ n) — indices of towns in which universities are located.

The next n - 1 line contains the description of roads. Each line contains the pair of integers xj and yj (1 ≤ xj, yj ≤ n), which means that the j-th road connects towns xj and yj. All of them are two-way roads. You can move from any town to any other using only these roads.

Output

Print the maximum possible sum of distances in the division of universities into k pairs.

Examples
Input
7 2
1 5 6 2
1 3
3 2
4 5
3 7
4 3
4 6
Output
6
Input
9 3
3 2 1 6 5 9
8 9
3 2
2 7
3 4
7 6
4 5
2 1
2 8
Output
9
Note

The figure below shows one of possible division into pairs in the first test. If you connect universities number 1 and 6 (marked in red) and universities number 2 and 5 (marked in blue) by using the cable, the total distance will equal 6 which will be the maximum sum in this example.


题意:有n个城镇和2k所大学,n-1条路,大学就位于城镇内,现在让你把大学两两相连,每
条路长度都是1,每所大学仅能和另一所大学相连,求出相连的路径和的最大值。
思路:首先这是一颗树,所以它比较特别,任意两点间只有唯一的一条道路相通,所以并不
需要知道它们之间具体是怎么连的,只需要知道每条道路被用过多少次,为了使得路径和最大,
那么就应该使连接的路尽量多。可以用dfs的方法遍历这棵树,每当处理完一个非叶子结点fa后,
记录这个结点的儿子结点里共多少个大学suma,和fa结点之外的大学数量sumb相比较,如果
sumb>suma,那么如果让fa和它的儿子结点互相连接的话,最长的道路就是从左经过fa绕到右,
如果让fa和它的儿子们往外连,它们不但要经过fa并且还要走更远,所以这样能使道路更长。反之,
sumb<suma就要把fa外面的结点往fa的和它的儿子结点里连,这样我们可以根据大学数量求出fa到
fa的父亲这一条路走了多少遍,加入结果。当一遍dfs完之后,答案就出来了。
代码很短。
#include <bits/stdc++.h>
using namespace std;
#define ll long long int
#define maxn 200010
struct node{
    int to, next;
}G[maxn*2];
int head[maxn*2], has[maxn], n, k, tot;
ll res;
bool vis[maxn];
int dfs(int fa){
    //printf("%d\n", fa);
    vis[fa] = 1;
    for(int i = head[fa];i!=-1;i=G[i].next){
        int son = G[i].to;
        if(vis[son]) continue;
        int tmp = dfs(son);
        has[fa] += tmp;
        if(2*k-tmp>=tmp) res += tmp;
        else res += (2*k-tmp);
        //printf("%d %d +%d\n", fa, son, res);
    }
    return has[fa];
}
void add(int u, int v){
    G[tot].to = v;
    G[tot].next = head[u];
    head[u]=tot++;
}
int main()
{
    int i, x, u, v;
    scanf("%d %d", &n, &k);
    memset(has, 0, sizeof has);
    memset(head, -1, sizeof head);
    for(i = 0;i < 2*k;i++){
        scanf("%d", &x);
        has[x] = 1;
    }
    tot = 0;
    for(i = 0;i < n-1;i++){
        scanf("%d %d", &u, &v);
        add(u, v);
        add(v, u);
    }
    memset(vis, 0, sizeof vis);
    res = 0;
    dfs(1);
    printf("%I64d\n", res);
}

                
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值